package com.goafanti.common.dao;

import com.goafanti.common.bo.OrderOperator;
import com.goafanti.common.bo.UserOrderTask;
import com.goafanti.common.model.TChangeTask;
import com.goafanti.common.model.TOrderTask;
import com.goafanti.order.bo.*;
import com.goafanti.order.bo.outStatistics.OutOrderNewSignBo;
import com.goafanti.organization.bo.ProjectTypePuls;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.math.BigDecimal;
import java.util.List;

/**
 * 订单任务表(TOrderTask)表数据库访问层
 *
 * @author makejava
 * @since 2024-09-27 15:05:35
 */
public interface TOrderTaskMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TOrderTask queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param tOrderTask 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<TOrderTask> findTOrderTaskList(TOrderTask tOrderTask, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param tOrderTask 查询条件
     * @return 总行数
     */
    int findTOrderTaskCount(TOrderTask tOrderTask);

    /**
     * 新增数据
     *
     * @param tOrderTask 实例对象
     * @return 影响行数
     */
    int insert(TOrderTask tOrderTask);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TOrderTask> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TOrderTask> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TOrderTask> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TOrderTask> entities);

    /**
     * 修改数据
     *
     * @param tOrderTask 实例对象
     * @return 影响行数
     */
    int update(TOrderTask tOrderTask);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);


    int insertSelective(TOrderTask record);

    List<TOrderTaskBo> selectOrderTask(@Param("orderNo") String orderNo,@Param("type") Integer type);

    TOrderTaskDetailBo getOrderTaskDetail(Integer id);

    TOrderTask selectBySuperId(String superId);

    List<TOrderTaskBo> getReceiverByOid(String oid);

    void updateDimissionTransfer(@Param("aid")String aid, @Param("transferId")String transferId, @Param("type")Integer type);

    String selectEstimateCost(@Param("orderNo")String orderNo);

    List<String> listNameByDepAndName(@Param("orderNo")String orderNo, @Param("type")Integer type);

    List<TOrderTaskListBo> splitProjectList( @Param("tid")Integer tid, @Param("type")Integer type);



    /**
     *
     * @param orderNo 订单编号
     * @param splitStatus null 所有 1主项目 2子项目 3所有项目
     * @return
     */
    List<TOrderTaskBo> selectOrderTaskAll(@Param("orderNo") String orderNo,@Param("splitStatus")Integer splitStatus);



    String selectByidGetCname(String pid);

    void updateByOutsourceToOrderNo(@Param("orderNo")String orderNo, @Param("type")Integer type);


    List<String> getLockId(@Param("orderNo")String orderNo, @Param("aid")String aid, @Param("uid")String uid);

    List<UserOrderTask> selectUidByproject(String uid);

    void resstPayment(Integer id);

    void updateAddCostAmount(@Param("tid")Integer tid, @Param("cost") BigDecimal cost);

    OrderOperator selectAidByParam(@Param("tid")Integer tid);

    ProjectTypePuls selectByTidGetDtails(Integer tid);

    List<OutHighNewRetrialStatistics> highNewRetrialStatistics(@Param("depId") String depId, @Param("startDate") String startDate, @Param("endDate") String endDate);

    int getHighNewRetrial(String orderNo);

    List<OutHighNewRetrialList> highNewRetrialList(@Param("province") String province, @Param("depId") String depId, @Param("aid") String aid,
                                                   @Param("sort") Integer sort, @Param("startDate") String startDate, @Param("endDate") String endDate);


    List<TChangeTask> selectByAid(String aid);

    Integer getSplitCount(Integer tid);


    void updateBySuperId(TOrderTask t);

    void deleteBySplitId(Integer id);

    void updateDimissionTransferManager(@Param("aid")String aid, @Param("transferId")String transferId);

    List<String> selectOrderNoAllByaid(String aid);


    List<TOrderTask> selectAll();

    List<TOrderTask> selectTasksByTid(Integer tid);

    List<TOrderTaskBo> selectAdminTaskByTid(Integer tid);
    List<TOrderTaskBo> selectAdminTaskByAid(String aid);

    List<OutOrderNewSignBo> orderNewSignToList(InputOrderNewSignBo in);
}

